VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.UserControl TablePanel 
   Appearance      =   0  'Flat
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "TablePanel.ctx":0000
   Begin MSFlexGridLib.MSFlexGrid grdTable 
      Height          =   3375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   5953
      _Version        =   393216
      Rows            =   1
      Cols            =   16
      BackColorBkg    =   -2147483633
      AllowBigSelection=   -1  'True
      ScrollTrack     =   -1  'True
      FocusRect       =   0
      GridLines       =   0
      SelectionMode   =   1
      AllowUserResizing=   1
      BorderStyle     =   0
   End
End
Attribute VB_Name = "TablePanel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private lib As MovieLib
Private currRow As Long

Private changing As Boolean

Event BeforeMove(ByRef Cancel As OLE_CANCELBOOL)
Event AfterMove()

Public Property Set Library(l As MovieLib)
  Set lib = l
  fillGrid
End Property

Public Property Let ColWidth(ByVal Index As Long, ByVal w As Long)
  grdTable.ColWidth(Index) = w
End Property

Public Property Get ColWidth(ByVal Index As Long) As Long
  ColWidth = grdTable.ColWidth(Index)
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_UserMemId = -514
  Enabled = UserControl.Enabled
End Property

Public Property Get Font() As Font
Attribute Font.VB_UserMemId = -512
  Set Font = UserControl.Font
End Property

Public Property Let Enabled(e As Boolean)
  UserControl.Enabled = e
  grdTable.Enabled = e
  PropertyChanged "Enabled"
End Property

Public Property Set Font(f As Font)
  Set UserControl.Font = f
  Set grdTable.Font = f
  PropertyChanged "Font"
End Property

Public Sub DeleteCurrent()
  grdTable.RemoveItem grdTable.Row
  HighlightCurrent
End Sub

Public Sub AddNew()
  Dim mv As Movie, r As Long
  Set mv = lib.Movie
  With grdTable
    If grdTable.Rows = 1 Then
      fillRow mv, 1
      HighlightCurrent
      Exit Sub
    End If
    r = 1
    While StrComp(mv.Index, .TextMatrix(r, 15), vbTextCompare) > 0
      r = r + 1
      If r = .Rows Then
        fillRow mv, r
        HighlightCurrent
        Exit Sub
      End If
    Wend
    fillRow mv, r
    HighlightCurrent
    For r = r + 1 To .Rows - 1
      .TextMatrix(r, 0) = r
    Next r
  End With
End Sub

Public Sub HighlightCurrent()
  Dim i As String, h As Long, l As Long, m As Long, r As Long
  i = lib.Movie.Index
  l = 1: h = grdTable.Rows - 1
  While l <= h
    m = (h + l) / 2
    r = StrComp(i, grdTable.TextMatrix(m, 15), vbTextCompare)
    If r = 0 Then
      With grdTable
        changing = True
        .Row = m
        .RowSel = m
        .Col = 1
        .ColSel = .Cols - 1
        changing = False
      End With
      currRow = m
      Exit Sub
    ElseIf r < 0 Then
      h = m - 1
    Else
      l = m + 1
    End If
  Wend
End Sub

Private Sub grdTable_SelChange()
  If changing Then Exit Sub
  Dim Cancel As OLE_CANCELBOOL, idx As Long
  With grdTable
    idx = .RowSel
    changing = True
    .Row = currRow
    .RowSel = .Row
    .Col = 1
    .ColSel = .Cols - 1
    changing = False
  End With
  RaiseEvent BeforeMove(Cancel)
  If Cancel Then Exit Sub
  currRow = idx
  With grdTable
    changing = True
    .RowSel = idx
    .Row = .RowSel
    .Col = 1
    .ColSel = .Cols - 1
    changing = False
    Call lib.Find(.TextMatrix(.Row, 15))
  End With
  RaiseEvent AfterMove
End Sub

Private Sub UserControl_EnterFocus()
  grdTable.BackColorSel = &H8000000D
  grdTable.ForeColorSel = &H8000000E
End Sub

Private Sub UserControl_ExitFocus()
  grdTable.BackColorSel = &H80000010
  grdTable.ForeColorSel = &H80000014
End Sub

Private Sub UserControl_Initialize()
  With grdTable
    .TextMatrix(0, 1) = "Title"
    .TextMatrix(0, 2) = "#"
    .TextMatrix(0, 3) = "Size"
    .TextMatrix(0, 4) = "Time"
    .TextMatrix(0, 5) = "Width"
    .TextMatrix(0, 6) = "Height"
    .TextMatrix(0, 7) = "Year"
    .TextMatrix(0, 8) = "CD"
    .TextMatrix(0, 9) = "HD"
    .TextMatrix(0, 10) = "IMDb"
    .TextMatrix(0, 11) = "Video Codec"
    .TextMatrix(0, 12) = "VBR"
    .TextMatrix(0, 13) = "Audio Codec"
    .TextMatrix(0, 14) = "ABR"
    .TextMatrix(0, 15) = "Index"
    .ColAlignment(1) = 0 'align left
    .ColWidth(0) = 420
    .ColWidth(1) = 3000
    .ColWidth(2) = 225
    .ColWidth(3) = 1140
    .ColWidth(4) = 690
    .ColWidth(5) = 600
    .ColWidth(6) = 600
    .ColWidth(7) = 450
    .ColWidth(8) = 330
    .ColWidth(9) = 330
    .ColWidth(10) = 2580
    .ColWidth(11) = 1050
    .ColWidth(12) = 450
    .ColWidth(13) = 1050
    .ColWidth(14) = 450
    .ColWidth(15) = 0
  End With
End Sub

Private Sub UserControl_InitProperties()
  Enabled = True
  Set Font = Ambient.Font
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Enabled = PropBag.ReadProperty("Enabled", True)
  Set Font = PropBag.ReadProperty("Font", Ambient.Font)
End Sub

Private Sub UserControl_Resize()
  grdTable.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub fillGrid()
  Dim mv As Movie
  grdTable.Rows = 1
  Set mv = lib.FirstMovie
  While Not mv Is Nothing
    fillRow mv, grdTable.Rows
    Set mv = lib.NextMovie
  Wend
  Call lib.FirstMovie
  With grdTable
    If .Rows > 1 Then
      .Row = 1
      .RowSel = 1
      .Col = 1
      .ColSel = .Cols - 1
      currRow = 1
    End If
  End With
End Sub

Private Sub fillRow(ByRef mv As Movie, ByVal r As Long)
  With mv
    grdTable.AddItem r, r
    grdTable.TextMatrix(r, 1) = .Title
    grdTable.TextMatrix(r, 2) = Format$(.Discs, "#")
    grdTable.TextMatrix(r, 3) = Format$(.Size, "#,###")
    grdTable.TextMatrix(r, 4) = Format$(.Time, "#:##:##")
    grdTable.TextMatrix(r, 5) = Format$(.Width, "#")
    grdTable.TextMatrix(r, 6) = Format$(.Height, "#")
    grdTable.TextMatrix(r, 7) = Format$(.Year, "#")
    grdTable.TextMatrix(r, 8) = YN$(.CD)
    grdTable.TextMatrix(r, 9) = YN$(.HD)
    grdTable.TextMatrix(r, 10) = .IMDBurl
    grdTable.TextMatrix(r, 11) = .VideoCodec
    grdTable.TextMatrix(r, 12) = Format$(.VBR, "#")
    grdTable.TextMatrix(r, 13) = .AudioCodec
    grdTable.TextMatrix(r, 14) = Format$(.ABR, "#")
    grdTable.TextMatrix(r, 15) = .Index
  End With
End Sub

Private Function YN$(ByVal tf As Boolean)
  YN$ = "N"
  If tf Then YN$ = "Y"
End Function

Private Sub UserControl_Terminate()
  Set lib = Nothing
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "Enabled", Enabled, True
  PropBag.WriteProperty "Font", Font, Ambient.Font
End Sub
